diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 943af4200..1cdba1545 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -102,6 +102,7 @@ import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumOS;
@@ -2057,8 +2058,12 @@ public class Minecraft
         Dimension lastDim = Dimension.getDimensionList().get(this.thePlayer.dimension);
         Dimension newDim = Dimension.getDimensionList().get(dim);
         LOGGER.info("Switching to dimension \"{}\"!!", newDim.getTranslatedName());
+        MobPig mount = this.thePlayer.vehicle instanceof MobPig p ? p : null;
         this.thePlayer.dimension = dim;
         this.currentWorld.setEntityDead(this.thePlayer);
+        if (mount != null) {
+            this.currentWorld.setEntityDead(mount);
+        }
         this.thePlayer.removed = false;
         double x = this.thePlayer.x;
         double z = this.thePlayer.z;
@@ -2095,6 +2100,14 @@ public class Minecraft
             this.thePlayer.moveTo(x, y, z, this.thePlayer.yRot, this.thePlayer.xRot);
             this.currentWorld.updateEntityWithOptionalForce(this.thePlayer, false);
             (new PortalHandler()).teleportEntity(this.currentWorld, this.thePlayer, portalColor, lastDim, newDim);
+            if (mount != null) {
+                this.thePlayer.clearPendingVehicleTag();
+                mount.removed = false;
+                mount.world = this.currentWorld;
+                mount.moveTo(this.thePlayer.x, this.thePlayer.y, this.thePlayer.z, mount.yRot, mount.xRot);
+                this.currentWorld.entityJoinedWorld(mount);
+                this.thePlayer.startRiding(mount);
+            }
         }
     }
 
@@ -2369,10 +2382,14 @@ public class Minecraft
 
         if (previousPlayer != null) {
             this.thePlayer.messageHistory = previousPlayer.messageHistory;
+            this.thePlayer.rotationLock = previousPlayer.rotationLock;
+            this.thePlayer.rotationLockHorizontal = previousPlayer.rotationLockHorizontal;
+            this.thePlayer.rotationLockVertical = previousPlayer.rotationLockVertical;
             if (!this.currentWorld.isClientSide) {
                 this.thePlayer.inventory.transferAllContents(previousPlayer.inventory);
             }
         }
+        this.thePlayer.syncPlacementMode();
 
         if (canRespawnAtBed) {
             this.thePlayer.setPlayerSpawnPoint(spawnCoordinates);
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 46ca4805d..9bad9c1ac 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -144,10 +144,8 @@ public class PlayerLocal extends Player {
         }
 
         this.prevTimeInPortal = this.timeInPortal;
-        if (this.inPortal && !this.hasNoPhysics()) {
-            if (!this.world.isClientSide && this.vehicle != null) {
-                startRiding(null);
-            }
+      
+        if (this.inPortal && !hasNoPhysics()) {
             if (this.mc.currentScreen instanceof ScreenContainerAbstract) // Close out of containers like the inventory
             {
                 this.mc.displayScreen(null);
@@ -402,12 +400,10 @@ public class PlayerLocal extends Player {
         }
         if (i > 0 && stat.isAchievement()) {
             Achievement achievement = (Achievement) stat;
-            if (achievement.parent == null || this.mc.statsCounter.isUnlocked(achievement.parent)) {
-                if (!this.mc.statsCounter.isUnlocked(achievement)) {
-                    this.mc.guiToasts.addToast(new AchievementToast(achievement, false));
-                }
-                this.mc.statsCounter.add(stat, i);
+            if (!this.mc.statsCounter.isUnlocked(achievement)) {
+                this.mc.guiToasts.addToast(new AchievementToast(achievement, false));
             }
+            this.mc.statsCounter.add(stat, i);
         } else {
             this.mc.statsCounter.add(stat, i);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
index 556f24d0d..1d5c84f87 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocalMultiplayer.java
@@ -7,8 +7,9 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.net.packet.PacketBoatControl;
+import net.minecraft.core.net.packet.PacketVehicleControl;
 import net.minecraft.core.net.packet.PacketMessage;
 import net.minecraft.core.net.packet.PacketPlayerConfig;
 import net.minecraft.core.net.packet.PacketUpdatePlayerState;
@@ -108,13 +109,7 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
         boolean hasRotated = yRotDiff != 0.0D || xRotDiff != 0.0D;
         if(vehicle != null)
         {
-            if(hasMoved)
-            {
-                sendQueue.addToSendQueue(new PacketMovePlayer.Pos(xd, -999D, zd, onGround));
-            } else
-            {
-                sendQueue.addToSendQueue(new PacketMovePlayer.PosRot(xd, -999D, zd, yRot, xRot, onGround));
-            }
+            sendQueue.addToSendQueue(new PacketMovePlayer.PosRot(xd, -999D, zd, yRot, xRot, onGround));
             hasMoved = false;
         } else if(hasMoved && hasRotated) {
             sendQueue.addToSendQueue(new PacketMovePlayer.PosRot(x, bb.minY, z, yRot, xRot, onGround));
@@ -259,7 +254,10 @@ public class PlayerLocalMultiplayer extends PlayerLocal implements Player.Player
     @Override
     public void sendSpecialVehiclePacket() {
         if (vehicle instanceof EntityBoat) {
-            sendQueue.addToSendQueue(new PacketBoatControl((EntityBoat) vehicle));
+            sendQueue.addToSendQueue(new PacketVehicleControl((Entity) vehicle));
+        } else if (vehicle instanceof MobPig pig) {
+            double trueY = pig.bb.minY + (double) pig.heightOffset;
+            sendQueue.addToSendQueue(new PacketVehicleControl(pig.id, pig.x, trueY, pig.z, pig.yRot, pig.consumePendingFallDistance()));
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
index dad670792..c6bcae7f4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
@@ -9,6 +9,8 @@ import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.console.shell.RuntimeExecutor;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.FontRendererDefault;
 import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.net.command.TextFormatting;
@@ -37,7 +39,10 @@ public class ScreenConsole extends Screen {
         private int width = 0;
         private int scroll = 0;
 
-        public LogRenderer() {
+        private final FontRenderer font;
+
+        public LogRenderer(FontRenderer font) {
+            this.font = font;
             this.preludes.put(LogMessage.Level.ERROR, TextFormatting.RED);
             this.preludes.put(LogMessage.Level.WARN, TextFormatting.YELLOW);
             this.preludes.put(LogMessage.Level.INFO, TextFormatting.WHITE);
@@ -65,14 +70,13 @@ public class ScreenConsole extends Screen {
                 this.scroll = 0;
             }
 
-            var font = Minecraft.getMinecraft().font;
-            font.startDrawingDeferred();
+            this.font.startDrawingDeferred();
             final int lines = Math.min(heightLines, WORKED_LINES.size() - this.scroll);
             for (int i = lines - 1; i >= 0; i--) {
                 final @NotNull String line = WORKED_LINES.get((WORKED_LINES.size() - 1) - (i + this.scroll));
-                font.render(line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i).setFont(Fonts.MONOSPACE).setColor(0xFF_CF_CF_CF).call();
+                this.font.render(line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i).setColor(0xFF_CF_CF_CF).call();
             }
-            font.draw(this.zLevel);
+            this.font.draw(this.zLevel);
             renderScrollIndicator(x, y, numLines);
         }
 
@@ -182,9 +186,11 @@ public class ScreenConsole extends Screen {
         private int historyIndex = 0;
 
         private final Highlighter<String> highlighter = new Highlighter<>(new RendererFactory());
+        private final FontRenderer font;
 
-        public InputRenderer() {
+        public InputRenderer(FontRenderer font) {
             this.editor = new TextFieldEditor(this, true);
+            this.font = font;
         }
 
         public void tick() {
@@ -195,31 +201,31 @@ public class ScreenConsole extends Screen {
             boolean addedStart = false;
             final @NotNull String @NotNull [] splitHighlighted = this.highlightedText.split("\n", -1);
             for (int i = 0; i < splitHighlighted.length; i++) {
-                Minecraft.getMinecraft().font.render((addedStart ? "  " : "> ") + splitHighlighted[i].replace("\n", ""), x, y).setFont(Fonts.MONOSPACE).setZ(this.zLevel).setColor(0xFF_E0_E0_E0).call();
+                this.font.render((addedStart ? "  " : "> ") + splitHighlighted[i].replace("\n", ""), x, y + i * LINE_HEIGHT).setZ(this.zLevel).setColor(0xFF_E0_E0_E0).call();
                 addedStart = true;
             }
 
             final @NotNull String @NotNull [] split = this.text.split("\n", -1);
-            final int offsetWidth = MathHelper.ceil(Minecraft.getMinecraft().font.stringWidthDouble("  "));
+            final int offsetWidth = MathHelper.ceil(this.font.stringWidthDouble("  "));
             final int[] cursorPos = getCursor();
             final int cursorX;
             if (cursorPos[0] == split[cursorPos[1]].length()) {
-                cursorX = MathHelper.ceil(Minecraft.getMinecraft().font.stringWidthDouble(split[cursorPos[1]]));
+                cursorX = MathHelper.ceil(this.font.stringWidthDouble(split[cursorPos[1]]));
             } else {
-                cursorX = MathHelper.ceil(Minecraft.getMinecraft().font.stringWidthDouble(split[cursorPos[1]].substring(0, cursorPos[0])));
+                cursorX = MathHelper.ceil(this.font.stringWidthDouble(split[cursorPos[1]].substring(0, cursorPos[0])));
             }
             if ((this.cursorCounter / 6) % 2 == 0) {
-                Minecraft.getMinecraft().font.render("█", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT).setFont(Fonts.MONOSPACE).setZ(this.zLevel).setColor(0xFF_FF_FF_FF).call();
+                this.font.render("█", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT).setZ(this.zLevel).setColor(0xFF_FF_FF_FF).call();
                 if (this.editor.getCursor() < this.text.length() && this.text.charAt(this.editor.getCursor()) != '\n') {
-                    Minecraft.getMinecraft().font.render("" + this.text.charAt(this.editor.getCursor()), x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT).setFont(Fonts.MONOSPACE).setZ(this.zLevel).setColor(0xFF_00_00_00).call();
+                    this.font.render("" + this.text.charAt(this.editor.getCursor()), x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT).setZ(this.zLevel).setColor(0xFF_00_00_00).call();
                 }
             } else {
-                Minecraft.getMinecraft().font.render("_", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT).setFont(Fonts.MONOSPACE).setZ(this.zLevel).setColor(0xFF_FF_FF_FF).call();
+                this.font.render("_", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT).setZ(this.zLevel).setColor(0xFF_FF_FF_FF).call();
             }
         }
 
         public void click(final int mx, final int my) {
-            final int oneChar = MathHelper.ceil(Minecraft.getMinecraft().font.stringWidthDouble(" "));
+            final int oneChar = MathHelper.ceil(this.font.stringWidthDouble(" "));
 
             final int cx = (mx - (oneChar * 2)) / oneChar;
             final int cy = my / LINE_HEIGHT;
@@ -382,12 +388,14 @@ public class ScreenConsole extends Screen {
 
     private final @NotNull LogRenderer logRenderer;
     private final @NotNull InputRenderer inputRenderer;
+    private final FontRenderer monospaceFont;
 
     public ScreenConsole(final @Nullable Screen parent) {
         super(parent);
-
-        this.logRenderer = new LogRenderer();
-        this.inputRenderer = new InputRenderer();
+        this.monospaceFont = new FontRendererDefault(Fonts.MONOSPACE);
+        this.monospaceFont.init();
+        this.logRenderer = new LogRenderer(this.monospaceFont);
+        this.inputRenderer = new InputRenderer(this.monospaceFont);
     }
 
     private int getMaxY() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
index 4a63e1bb0..eaf8818d5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
@@ -183,12 +183,7 @@ public class ScreenHudEditor extends Screen {
         }
 
         if (eventKey == GameSettings.KEY_HUD_EDITOR_RESET.getKeyCode()) {
-            HudComponents.INSTANCE.fromSettingsString(HudComponents.DEFAULT_LAYOUT);
-            for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
-                for (Option<?> option : component.getRawOptions()) {
-                    option.resetValueToDefault();
-                }
-            }
+            HudComponents.INSTANCE.resetToDefault();
             this.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
             return;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
index 90b1e8cdb..4767708ca 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
@@ -116,7 +116,11 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
             GameSettings.LAST_CREATIVE_INVENTORY_PAGE.set(clamped);
             GameSettings.saveOptions();
         }
-        this.container.setInventoryStatus(clamped, this.container.searchText);
+        if (clamped == this.container.page) {
+            this.container.broadcastInventoryStatus();
+        } else {
+            this.container.setInventoryStatus(clamped, this.container.searchText);
+        }
     }
 
     private void persistCreativeInventoryPage() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index ef2f5e185..5820f286c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -19,7 +19,9 @@ import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorShader;
 import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
+import net.minecraft.core.block.BlockLogicConduit;
 import net.minecraft.core.block.BlockLogicPortal;
+import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Direction;
@@ -385,8 +387,14 @@ public class HudIngame extends Gui {
                         drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Light: Sky: ").append(this.mc.currentWorld.getSavedLightValue(LightLayer.Sky, lightX, lightY, lightZ)).append(" Block: ").append(this.mc.currentWorld.getSavedLightValue(LightLayer.Block, lightX, lightY, lightZ))); hudBuilder.setLength(0);
                     }
 
-                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Signal: ").append(this.mc.currentWorld.hasSignal(hitTile.tilePos, hitTile.side))); hudBuilder.setLength(0);
-                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Direct signal: ").append(this.mc.currentWorld.hasDirectSignal(hitTile.tilePos, hitTile.side))); hudBuilder.setLength(0);
+                    Side signalSide = hitTile.side.opposite();
+                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Signal: ").append(this.mc.currentWorld.hasSignal(hitTile.tilePos, signalSide))); hudBuilder.setLength(0);
+                    drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Direct signal: ").append(this.mc.currentWorld.hasDirectSignal(hitTile.tilePos, signalSide))); hudBuilder.setLength(0);
+
+                    int signalStrength = getSignalStrength(block, meta, hitTile.tilePos);
+                    if (signalStrength >= 0) {
+                        drawDebugScreenLineRight(hudTessellater, hudBuilder.append("Signal strength: ").append(signalStrength)); hudBuilder.setLength(0);
+                    }
 
                     for (Tag<Block<?>> tag : BlockTags.TAG_LIST) {
                         if (tag.appliesTo(block)) {
@@ -734,4 +742,26 @@ public class HudIngame extends Gui {
     public static Direction getFacingDirection(Player player) {
         return directions[(MathHelper.floor((double) ((player.yRot * 4F) / 360F) + 0.5D) + 2) & 3];
     }
+
+    /**
+     * Resolves the 0-15 redstone signal strength emitted by a redstone component.
+     * Returns -1 for blocks that are not redstone components, signalling that no line should be drawn.
+     */
+    private int getSignalStrength(final @NotNull Block<?> block, final int meta, final @NotNull net.minecraft.core.world.pos.TilePosc tilePos) {
+        if (block == Blocks.WIRE_REDSTONE) {
+            return meta & BlockLogicWireRedstone.MASK_POWER;
+        }
+        if (block == Blocks.CONDUIT) {
+            return BlockLogicConduit.getPower(this.mc.currentWorld, tilePos);
+        }
+        if (block.isSignalSource()) {
+            for (final Side side : Side.sides) {
+                if (this.mc.currentWorld.hasSignal(tilePos, side)) {
+                    return BlockLogicWireRedstone.SIGNAL_MAX;
+                }
+            }
+            return BlockLogicWireRedstone.SIGNAL_MIN;
+        }
+        return -1;
+    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
index 6b089a1da..75025ead8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
@@ -86,7 +86,7 @@ public abstract class HudComponent {
     }
 
     public void setScaleOverride(int value) {
-        this.getGuiScaleOverrideOption().value = Math.max(0, value);
+        this.getGuiScaleOverrideOption().value = OptionGuiScaleOverride.clampValue(value);
     }
 
     public static int getEffectiveGlobalScale() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 6ee04f34d..895b47967 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -7,6 +7,7 @@ import net.minecraft.client.gui.options.components.BooleanOptionComponent;
 import net.minecraft.client.gui.options.components.KeyBindingComponent;
 import net.minecraft.client.gui.options.components.ToggleableOptionComponent;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.Option;
 import net.minecraft.core.enums.HumanArmorShape;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -148,6 +149,18 @@ public class HudComponents {
         return this.components;
     }
 
+    public void resetToDefault() {
+        if (DEFAULT_LAYOUT == null) {
+            return;
+        }
+        fromSettingsString(DEFAULT_LAYOUT);
+        for (HudComponent component : getComponents()) {
+            for (Option<?> option : component.getRawOptions()) {
+                option.resetValueToDefault();
+            }
+        }
+    }
+
     public @Nullable HudComponent getComponent(String key) {
         for (HudComponent component : this.components) {
             if (component.getKey().equals(key)) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index d2dbd742c..638f06345 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -522,6 +522,10 @@ public abstract class OptionsPages {
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.reload_commands", () ->{
                     if (Minecraft.getMinecraft().currentWorld != null) Minecraft.getMinecraft().currentWorld.getCommandManager().reload();
                 }))
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.reset_hud_onboarding", () -> {
+                    GameSettings.SEEN_HUD_EDITOR_ONBOARDING.set(false);
+                    GameSettings.saveOptions();
+                }))
             ));
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 47d2bc3f8..0bd4e7842 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -41,7 +41,6 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.Projectile;
-import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemMap;
 import net.minecraft.core.item.ItemStack;
@@ -292,14 +291,19 @@ public class PacketHandlerClient extends PacketHandler {
     @Override
     public void handleEntityFling(final @NotNull PacketEntityFling packetEntityFling) {
         final Entity entity = getEntityByID(packetEntityFling.entityId);
-        if (entity != null) {
-            entity.pushesThisTick = packetEntityFling.pushesTick;
-            entity.fallDistance = 0;
-            entity.xd = packetEntityFling.xd;
-            entity.yd = packetEntityFling.yd;
-            entity.zd = packetEntityFling.zd;
-            entity.pushTime = packetEntityFling.pushTime;
+        if (entity == null) {
+            return;
+        }
+        if (entity == this.mc.thePlayer.vehicle) {
+            entity.fling(packetEntityFling.xd, packetEntityFling.yd, packetEntityFling.zd, packetEntityFling.pushTime);
+            return;
         }
+        entity.pushesThisTick = packetEntityFling.pushesTick;
+        entity.fallDistance = 0;
+        entity.xd = packetEntityFling.xd;
+        entity.yd = packetEntityFling.yd;
+        entity.zd = packetEntityFling.zd;
+        entity.pushTime = packetEntityFling.pushTime;
     }
 
     @Override
@@ -606,10 +610,10 @@ public class PacketHandlerClient extends PacketHandler {
     }
 
     @Override
-    public void handleBoatControl(@NotNull PacketBoatControl packetBoatControl) {
-        Entity e = this.worldClientMP.getEntityFromId(packetBoatControl.entityId);
-        if (e instanceof EntityBoat) {
-            ((EntityBoat) e).handleControlDirect(packetBoatControl.targetXD, packetBoatControl.targetZD, packetBoatControl.targetYRot);
+    public void handleVehicleControl(@NotNull PacketVehicleControl packetVehicleControl) {
+        Entity e = this.worldClientMP.getEntityFromId(packetVehicleControl.entityId);
+        if (e != null) {
+            e.handleControlDirect(packetVehicleControl.targetXD, packetVehicleControl.targetYD, packetVehicleControl.targetZD, packetVehicleControl.targetYRot);
         }
     }
 
@@ -732,8 +736,12 @@ public class PacketHandlerClient extends PacketHandler {
         } else {
             vehicle = getEntityByID(packetSetRiding.vehicleId);
         }
-        if (passenger != null && vehicle != null) {
-            passenger.startRiding(vehicle);
+        if (passenger != null) {
+            if (vehicle != null) {
+                passenger.startRiding(vehicle);
+            } else if (!packetSetRiding.isTileEntity && packetSetRiding.vehicleId == -1) {
+                passenger.startRiding(null);
+            }
         }
     }
 
@@ -793,6 +801,7 @@ public class PacketHandlerClient extends PacketHandler {
             this.worldClientMP.isClientSide = true;
             this.mc.changeWorld(this.worldClientMP);
             this.mc.thePlayer.dimension = packetRespawn.respawnDimensionId;
+            this.mc.thePlayer.vehicle = null;
             this.mc.displayScreen(new ScreenDownloadTerrain(this));
         }
         this.mc.respawn(true, packetRespawn.respawnDimensionId);
@@ -884,42 +893,35 @@ public class PacketHandlerClient extends PacketHandler {
     public void handleContainerSetSlot(@NotNull PacketContainerSetSlot packetContainerSetSlot) {
         if (packetContainerSetSlot.windowId == -1) {
             this.mc.thePlayer.inventory.setHeldItemStack(packetContainerSetSlot.myItemStack);
+            this.mc.thePlayer.containerMenu.stateId = packetContainerSetSlot.stateId;
         } else if (packetContainerSetSlot.windowId == 0 && packetContainerSetSlot.itemSlot >= ContainerInventory.MAIN_INVENTORY_SIZE && packetContainerSetSlot.itemSlot < ContainerInventory.MAIN_INVENTORY_SIZE + ContainerInventory.HOTBAR_SIZE) {
             ItemStack itemstack = this.mc.thePlayer.inventoryMenu.getSlot(packetContainerSetSlot.itemSlot).getItemStack();
             if (packetContainerSetSlot.myItemStack != null && (itemstack == null || itemstack.stackSize < packetContainerSetSlot.myItemStack.stackSize)) {
                 packetContainerSetSlot.myItemStack.animationsToGo = 5;
             }
             this.mc.thePlayer.inventoryMenu.setItem(packetContainerSetSlot.itemSlot, packetContainerSetSlot.myItemStack);
+            this.mc.thePlayer.inventoryMenu.stateId = packetContainerSetSlot.stateId;
         } else if (packetContainerSetSlot.windowId == this.mc.thePlayer.containerMenu.containerId) {
             this.mc.thePlayer.containerMenu.setItem(packetContainerSetSlot.itemSlot, packetContainerSetSlot.myItemStack);
+            this.mc.thePlayer.containerMenu.stateId = packetContainerSetSlot.stateId;
         }
     }
 
     @Override
     public void handleContainerAck(@NotNull PacketContainerAck packetContainerAck) {
-        MenuAbstract container = null;
-        if (packetContainerAck.windowId == 0) {
-            container = this.mc.thePlayer.inventoryMenu;
-        } else if (packetContainerAck.windowId == this.mc.thePlayer.containerMenu.containerId) {
-            container = this.mc.thePlayer.containerMenu;
-        }
-        if (container != null) {
-            if (packetContainerAck.accepted) {
-                container.deleteBackup(packetContainerAck.shortWindowId);
-            } else {
-                container.rollbackToBackup(packetContainerAck.shortWindowId);
-                addToSendQueue(new PacketContainerAck(packetContainerAck.windowId, packetContainerAck.shortWindowId, true));
-            }
-        }
+        //reconciliation of state ids and delta corrections render container ack deprecated
     }
 
     @Override
     public void handleContainerSetContent(@NotNull PacketContainerSetContent packetContainerSetContent) {
         if (packetContainerSetContent.windowId == 0) {
             this.mc.thePlayer.inventoryMenu.setAll(packetContainerSetContent.stackList);
+            this.mc.thePlayer.inventoryMenu.stateId = packetContainerSetContent.stateId;
         } else if (packetContainerSetContent.windowId == this.mc.thePlayer.containerMenu.containerId) {
             this.mc.thePlayer.containerMenu.setAll(packetContainerSetContent.stackList);
+            this.mc.thePlayer.containerMenu.stateId = packetContainerSetContent.stateId;
         }
+        this.mc.thePlayer.inventory.setHeldItemStack(packetContainerSetContent.carriedItem);
     }
 
     @Override
